#!/usr/bin/python
# coding: utf-8

import os
import cgitb
import random
import re
import sys
import time
import cgi

def main():
	path = os.environ["PATH_INFO"]
	
	print "Content-Type: text/xml"
	print 
	print '<?xml version="1.0" encoding="UTF-8"?>'
	
	if path=="/user/login":
		login()
	elif path=="/user/isValidUser":
		isValidUser()
	elif path=="/game/start":
		start()
	elif path=="/game/postAnswer":
		postAnswer()
	elif path=="/game/pgames":
		pgames()
	elif path=="/game/pgame":
		f = cgi.FieldStorage()
		pgame(int(f.getfirst("id")))
	elif path=="/user/logout":
		logout()

def login():
	print """<response>
 <ok>
  <code />
  <body />
 </ok>
</response>
"""

def logout():
	print """<response>
 <ok>
  <code />
  <body />
 </ok>
</response>
"""

def isValidUser():
	print """<response> <ok>
  <code>valid</code>
  <body />
 </ok>
</response>
"""

def start():
	print """<response>
 <ok>
  <code>problem_created</code>
  <body>
   <id>12345678</id>
   <problem>%s</problem>
   <limit>2013-12-31 00:00:00</limit>
  </body>
 </ok>
</response>
"""%random.randint(0,2**31-1)

data = "data"
fmt = "%Y-%m-%d %H_%M_%S.txt"

def postAnswer():
	d = sys.stdin.read()
	if d=="":
		return
		
	open(os.path.join(data,time.strftime(fmt)),"wb").write(d)
	
	print """<response>
 <ok>
  <code>answer_received</code>
  <body />
 </ok>
</response>
"""

def pgames():
	print """<response>
 <ok>
  <code>past_games</code>
  <body>"""
	for f in os.listdir(data):
		try:
			id = int(time.mktime(time.strptime(f,fmt)))
			tm = f[:-4].replace("_",":")
			l = open(os.path.join(data,f),"rb").readlines(5)
			stage = sum(int(x)for x in l[2].split()[1:])
			money = int(l[4].split()[stage])
			
			print """   <item>
    <id>%s</id>
    <money_left>%s</money_left>
    <max_stage>%s</max_stage>
    <is_valid>1</is_valid>
    <validation_result>ok</validation_result>
    <problem_sent_at>%s</problem_sent_at>
    <answered_at>%s</answered_at>
   </item>
"""%(id,money,stage,tm,tm)
		except:
			pass 
	print """  </body>
 </ok>
</response>"""

def pgame(id):
	d = open(os.path.join(data,time.strftime(fmt,time.localtime(id)))).read()
	print """<response>
 <ok>
  <code>past_game</code>
  <body>
   <id>0</id>
   <user_id>0</user_id>
   <problem>12345678</problem>
   <answer>%s</answer>
   <abstract>%s</abstract>
   <max_stage>0</max_stage>
   <money_left>0</money_left>
   <problem_sent_at>2011-12-26 00:00:00</problem_sent_at>
   <answered_at>2011-12-26 00:00:00</answered_at>
  </body>
 </ok>
</response>
"""%(d,d)

if __name__=="__main__":
	#cgitb.enable()
	try:
		main()
	except:
		pass
